`define STDIN  (32'h80000000)
`define STDOUT (32'h80000001)
`define EOF    (32'hFFFFFFFF)

module grayscale;

    reg [31:0] ret, index;
    reg [7:0] data[2**20-1:0]; // サイズ2^20の8bit幅のデータ配列

    initial begin
        index = 0;
        ret = $fgetc(`STDIN);
        while(ret != `EOF) begin // 標準入力からEOFまでデータを読み込む
            data[index] = ret[7:0];
            index = index + 1;
            ret = $fgetc(`STDIN);
        end
        $write("bfType: %c%c\n", data[0], data[1]);
        $write("bfSize:         %10d\n", {data[5], data[4], data[3], data[2]});
        $write("bfOffBits:      %10d\n", {data[13], data[12], data[11], data[10]});
        $write("biSize:         %10d\n", {data[17], data[16], data[15], data[14]});
        $write("biWidth:        %10d\n", {data[21], data[20], data[19], data[18]});
        $write("biHeight:       %10d\n", {data[25], data[24], data[23], data[22]});
        $write("biPlanes:       %10d\n", {data[27], data[26]});
        $write("biBitCount:     %10d\n", {data[29], data[28]});
        $write("biCompression:  %10d\n", {data[33], data[32], data[31], data[30]});
        $write("biSizeImage:    %10d\n", {data[37], data[36], data[35], data[34]});
        $write("biPixPerMeter:  %10d\n", {data[41], data[40], data[39], data[38]});
        $write("biYPixPerMeter: %10d\n", {data[45], data[44], data[43], data[42]});
        $write("biClrUsed:      %10d\n", {data[49], data[48], data[47], data[46]});
        $write("biCirImportant: %10d\n", {data[53], data[52], data[51], data[50]});
    end

endmodule
