`define STDIN  (32'h80000000)
`define STDOUT (32'h80000001)
`define EOF    (32'hFFFFFFFF)

module grayscale;

    reg [31:0] ret, index;
    reg [7:0] data[2**20-1:0];

    reg [31:0] offset, width, height;
    reg [32:0] i = 0;
    reg [16:0] r0, g0, b0, r1, g1, b1;
    reg [16:0] val0, val1;
    reg clk  = 1'b0;
    reg done = 1'b0;

    reg [1:0] state = 0;

    always @(posedge clk) begin
        if(i < width * height) begin
        end else begin
            done <= 1;
        end
	if(state == 0) begin
	    b0 <= {8'h00, data[3*(i+0)+offset  ]};
	    g0 <= {8'h00, data[3*(i+0)+offset+1]};
	    r0 <= {8'h00, data[3*(i+0)+offset+2]};
	    b1 <= {8'h00, data[3*(i+1)+offset  ]};
	    g1 <= {8'h00, data[3*(i+1)+offset+1]};
	    r1 <= {8'h00, data[3*(i+1)+offset+2]};
	    state <= 1;
	end else if(state == 1) begin
	    val0 <= (77 * r0 + 150 * g0 + 29 * b0) >> 8;
	    val1 <= (77 * r1 + 150 * g1 + 29 * b1) >> 8;
	    state <= 2;
	end else begin
	    data[3*(i+0)+offset  ] <= val0;
	    data[3*(i+0)+offset+1] <= val0;
	    data[3*(i+0)+offset+2] <= val0;
	    data[3*(i+1)+offset  ] <= val1;
	    data[3*(i+1)+offset+1] <= val1;
	    data[3*(i+1)+offset+2] <= val1;
	    i <= i + 2;
	    state <= 0;
	end
    end

    initial begin
        clk = 0;
        index = 0;
        ret = $fgetc(`STDIN);
        while(ret != `EOF) begin
            data[index] = ret & 8'hFF;
            index = index + 1;
            ret = $fgetc(`STDIN);
        end
        offset = {data[13], data[12], data[11], data[10]};
        width  = {data[21], data[20], data[19], data[18]};
        height = {data[25], data[24], data[23], data[22]};
        while(!done) begin
            clk = 0; #10;
            clk = 1; #10;
        end
        for(i = 0; i < index; i = i + 1) begin
            ret = $fputc(data[i], `STDOUT);
        end
        $finish;
    end


endmodule
